<template>
  <BaseProjectCard
    :title="skeleton ? '' : scenario.title"
    :main-user="skeleton ? {} : mainUser"
    :date="skeleton ? '' : creationDatetime"
    :skeleton="skeleton"
  >
    <template #header>
      <h3 class="card-title"></h3>
      <div v-if="skeleton" class="card-options w-100">
        <div class="mr-auto"></div>
        <DotsVerticalIcon class="mt-1" />
      </div>
      <div v-else class="card-options w-100">
        <b-col cols="auto" class="mr-auto mt-1 px-0">
          <a class="text-scenarios">
            <AlertCircleIcon
              v-if="notReady"
              v-b-tooltip.hover.bottom="{ variant: 'dark' }"
              class="icon-right text-gray"
              title="Scenario has not been configured"
            />
            <AlertTriangleIcon
              v-else-if="hasError"
              v-b-tooltip.hover.bottom="{ variant: 'dark' }"
              class="icon-right text-orange"
              title="Scenario has configuration errors"
            />
            <CircleCheckIcon
              v-else
              v-b-tooltip.hover.bottom="{ variant: 'dark' }"
              class="icon-right"
              title="No issues found"
            />
          </a>
        </b-col>
        <b-col cols="auto" class="mr-1 px-0">
          <NuxtLink
            data-cy="configure-scenario-btn"
            :to="`/projects/${projectId}/configure/${scenario.id}`"
            class="btn btn-scenarios btn-sm btn-configure-sce"
          >
            <AdjustmentsIcon class="icon-xxs" />
            Configure
          </NuxtLink>
        </b-col>
        <b-dropdown
          variant="link"
          toggle-tag="a"
          toggle-class="p-0 card-dropdown dropdown-job-actions"
          no-caret
          right
        >
          <template #button-content>
            <DotsVerticalIcon />
          </template>
          <b-dropdown-item link-class="pt-1 pb-1" disabled>
            <LetterCaseIcon class="dropdown-item-icon" />
            Rename
          </b-dropdown-item>
          <b-dropdown-item link-class="pt-1 pb-1" disabled>
            <CopyIcon class="dropdown-item-icon" />
            Duplicate
          </b-dropdown-item>
          <b-dropdown-item
            data-cy="unlink-scenario"
            link-class="pt-1 pb-1"
            @click="removeScenario()"
          >
            <TrashIcon class="dropdown-item-icon" />
            Remove
          </b-dropdown-item>
        </b-dropdown>
      </div>
    </template>
    <template #pretitle>
      <div v-if="skeleton" class="skeleton-cardtype mx-auto mb-2">
        <ContentLoader width="40" height="8">
          <rect x="0" y="0" rx="3" ry="3" width="40" height="8" />
        </ContentLoader>
      </div>
      <div v-else class="card-type card-type-scenmario small">
        <span class="badge bg-scenarios-lt badge-small-text text-uppercase">
          scenario
        </span>
      </div>
    </template>
    <template #subtitle>
      <div class="mt-0 mb-0">
        <div v-if="skeleton" class="skeleton-subtitle mx-auto mt-1">
          <ContentLoader width="30" height="10">
            <rect x="0" y="0" rx="4" ry="4" width="30" height="10" />
          </ContentLoader>
        </div>
        <span v-else class="text-vrsion small mt-0 ml-3 mr-3">
          {{ scenario.version }}
        </span>
      </div>
    </template>
    <template #body-bottom>
      <div class="mt-3">
        <div class="avatar-list avatar-list-stacked">
          <Avatar v-if="skeleton" />
          <template v-else>
            <Avatar
              v-b-tooltip.hover.right="{ variant: 'dark' }"
              title="RISIS Datastore"
              badge="bg-online"
            >
              <AppsIcon />
            </Avatar>
            <Avatar img="/avatars/001s.png" badge="bg-online" />
          </template>
        </div>
      </div>
    </template>
    <template #description>
      <div class="mt-3 mb-2 text-justify">
        <ContentLoader v-if="skeleton" width="300" height="60">
          <rect x="0" y="0" rx="3" ry="3" width="300" height="12" />
          <rect x="0" y="20" rx="3" ry="3" width="300" height="12" />
          <rect x="0" y="40" rx="3" ry="3" width="100" height="12" />
        </ContentLoader>
        <template v-else>
          <div class="markdown lh-base small text-clamp-2 mb-0">
            {{ scenario.description }}
          </div>
          <a
            v-if="scenario.description.length > 60"
            v-b-tooltip.hover.top="{ variant: 'dark' }"
            :title="scenario.description"
            class="d-flex h6 cursor-default"
            >Learn more...</a
          >
        </template>
      </div>
    </template>
    <template #badges>
      <div v-if="skeleton" class="lh-sm w-100">
        <ContentLoader width="300" height="25">
          <rect x="0" y="0" rx="10" ry="10" width="300" height="25" />
        </ContentLoader>
      </div>
      <template v-else>
        <div class="lh-sm w-100 cursor-not-allowed">
          <a class="disabled-action">
            <b-badge class="badge-small-text text-uppercase bg-indigo-lt w-100">
              <TagIcon class="icon-xxs" />
            </b-badge>
          </a>
        </div>
        &nbsp;
        <div class="lh-sm w-100 cursor-not-allowed">
          <a class="disabled-action">
            <b-badge class="badge-small-text text-uppercase bg-blue-lt w-100">
              <DatabaseIcon class="icon-xxs" />
            </b-badge>
          </a>
        </div>
      </template>
    </template>
    <template #progress>
      <b-progress
        class="card-progress"
        :class="scenarioRunning ? 'progress-bar-indeterminate' : ''"
      >
        <b-progress-bar
          :class="scenarioRunning ? 'w-100' : 'w-0'"
        ></b-progress-bar>
      </b-progress>
    </template>
  </BaseProjectCard>
</template>

<script>
import notificationsMixin from '~/mixins/notifications.js';

export default {
  mixins: [notificationsMixin],
  props: {
    scenario: {
      type: Object,
      default() {
        return {
          fullName: '',
          firstName: '',
        };
      },
    },
    date: {
      type: String,
      default: '',
    },
    scenarioRunning: {
      type: Boolean,
      default: false,
    },
    skeleton: {
      type: Boolean,
      default: false,
    },
  },
  data() {
    return {
      showVersions: false,
    };
  },
  computed: {
    projectId() {
      return this.$nuxt.$route.params.id;
    },
    mainUser() {
      return {
        firstName: this.scenario.owners ? this.scenario.owners[0] : '',
      };
    },
    creationDatetime() {
      const date = this.scenario.date;
      if (date && date.creation) {
        return date.creation;
      }
      return this.scenario.creation_datetime;
    },
    notReady() {
      return this.scenario.state === 'not-ready';
    },
    hasError() {
      return this.$store.getters['scenarios/hasError'](this.scenario.id);
    },
  },
  methods: {
    async removeScenario() {
      await this.$nuxt.context.store
        .dispatch('projects/unlinkScenario', {
          projectId: this.projectId,
          scenarioId: this.scenario.id,
        })
        .catch(() => {
          this.showErrorNotification('Error unlinking scenario');
        });
    },
  },
};
</script>

<style>
.skeleton-cardtype {
  min-width: 50px;
  max-width: 40%;
}
.skeleton-subtitle {
  min-width: 30px;
  max-width: 20%;
}
</style>
